#include <sdktools>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo =
{
	name	= "Round Start Music",
	version	= "1.3.1",
	author	= "wS",
};

#define SZF(%0) %0, sizeof(%0)
#define HAS_FLAGS(%0,%1) (((%0) & (%1)) == (%1))

/////

#undef REQUIRE_PLUGIN
#include <clientprefs>

public void OnLibraryAdded(const char[] name) {
	OnLibStateChanged(name, true );
}

public void OnLibraryRemoved(const char[] name) {
	OnLibStateChanged(name, false);
}

Handle g_Cookie;

static void OnLibStateChanged(const char[] name, bool state)
{
	if ((name[0] == 'c') && !strcmp(name, "clientprefs")) {
		if (state) {
			if (!g_Cookie && (g_Cookie = RegClientCookie("Round Start Music", "", CookieAccess_Private))) {
				for (int client; ++client <= MaxClients;) {
					if (IsClientInGame(client) && AreClientCookiesCached(client)) {
						OnClientCookiesCached(client);
					}
				}
			}
		}
		else{
			g_Cookie = null; // CloseHandle = error
		}
	}
}

/////

#define 	FL_OnClientCookiesCached 	(1 << 0)
#define 	FL_ENABLED 					(1 << 1)

StringMap 	g_Tr;
int			g_TrSize;
int			g_CurrentSoundNumber;
int 		g_Flags[MAXPLAYERS + 1] = {FL_ENABLED, ...};
char 		g_LastSound[PLATFORM_MAX_PATH];

bool		rss_random;
bool		rss_round_freeze_end;
bool		rss_round_end_stop;

public void OnPluginStart()
{
	/////

	SF_HookConVarChange(CreateConVar("rss_random", "1", "Музыка в начале раунда в случайном порядке (1 = да, 0 = нет)"), rss_random_);
	SF_HookConVarChange(CreateConVar("rss_round_freeze_end", "1", "1 = музыка проигрывается после mp_freezetime.\n0 = сразу же после начала раунда."), rss_round_freeze_end_);
	SF_HookConVarChange(CreateConVar("rss_round_end_stop", "1", "Остановить музыку, если раунд завершился (1 = да, 0 = нет)"), rss_round_end_stop_);

	AutoExecConfig();

	/////

	HookEvent("round_start"		 , Event_round_start	  , EventHookMode_PostNoCopy);
	HookEvent("round_freeze_end" , Event_round_start	  , EventHookMode_PostNoCopy);
	HookEvent("round_end" 		 , Event_round_end	  	  , EventHookMode_PostNoCopy);
	HookEvent("player_disconnect", Event_player_disconnect, EventHookMode_Post);

	RegConsoleCmd("sm_rsm", OnCmd);
}

static void rss_random_(ConVar convar, const char[] oldValue, const char[] newValue) {
	rss_random = convar.BoolValue;
}

static void rss_round_freeze_end_(ConVar convar, const char[] oldValue, const char[] newValue) {
	rss_round_freeze_end = convar.BoolValue;
}

static void rss_round_end_stop_(ConVar convar, const char[] oldValue, const char[] newValue) {
	rss_round_end_stop = convar.BoolValue;
}

public void OnMapStart()
{
	g_TrSize = 0;
	g_LastSound[0] = 0;

	if (g_Tr) {
		g_Tr.Clear();
	}
	else{
		g_Tr = new StringMap();
	}

	DirectoryListing dir = OpenDirectory("sound/round_start_music");
	if (dir)
	{
		char 		sound[PLATFORM_MAX_PATH];
		FileType 	fileType;
		bool 		csgo = GetEngineVersion() == Engine_CSGO;

		while (dir.GetNext(SZF(sound), fileType))
		{
			if ((fileType == FileType_File) && SF_IsSound(sound))
			{
				Format(SZF(sound), "sound/round_start_music/%s", sound);
				AddFileToDownloadsTable(sound);

				if (csgo)
				{
					Format(SZF(sound), "*%s", sound[6]);

					static int t = INVALID_STRING_TABLE;
					if ((t != INVALID_STRING_TABLE) || ((t = FindStringTable("soundprecache")) != INVALID_STRING_TABLE)) {
						AddToStringTable(t, sound);
					}
				}
				else
				{
					strcopy(SZF(sound), sound[6]);
					PrecacheSound(sound);
				}

				g_Tr.SetString(SF_AnyToStr(++g_TrSize), sound);
			}
		}

		CloseHandle(dir);
	}
}

static void Event_round_start(Event event, const char[] name, bool dontBroadcast)
{
	if (g_TrSize && ((rss_round_freeze_end && (name[6] == 'f')) || (!rss_round_freeze_end && (name[6] == 's'))))
	{
		if (rss_random && (g_TrSize > 1)) {
			g_CurrentSoundNumber = GetRandomInt(1, g_TrSize);
		}
		else if (++g_CurrentSoundNumber > g_TrSize) {
			g_CurrentSoundNumber = 1;
		}
		
		if (g_Tr.GetString(SF_AnyToStr(g_CurrentSoundNumber), SZF(g_LastSound))) {
			for (int client; ++client <= MaxClients;) {
				if ((g_Flags[client] & FL_ENABLED) && IsClientInGame(client) && !IsFakeClient(client)) {
					EmitSoundToClient(client, g_LastSound);
				}
			}
		}
	}
}

static void Event_round_end(Event event, const char[] name, bool dontBroadcast)
{
	if (rss_round_end_stop && g_LastSound[0]) {
		for (int client; ++client <= MaxClients;) {
			if ((g_Flags[client] & FL_ENABLED) && IsClientInGame(client) && !IsFakeClient(client)) {
				StopSound(client, SNDCHAN_AUTO, g_LastSound);
			}
		}
	}
}

static Action OnCmd(int client, int args)
{
	if (g_TrSize && (client > 0) && (client <= MaxClients) && IsClientInGame(client))
	{
		if (SF_AddFlag(g_Flags[client], FL_ENABLED)) {
			PrintToChat(client, "Round Start Music: \x04ON");
		}
		else
		{
			g_Flags[client] &= ~FL_ENABLED;
			PrintToChat(client, "Round Start Music: OFF");

			if (g_LastSound[0]) { 
				StopSound(client, SNDCHAN_AUTO, g_LastSound);
			}
		}

		if (g_Cookie) {
			SetClientCookie(client, g_Cookie, (g_Flags[client] & FL_ENABLED) ? "1" : "0");
		}
	}
	return Plugin_Handled;
}

static void Event_player_disconnect(Event event, const char[] name, bool dontBroadcast)
{
	g_Flags[GetClientOfUserId(event.GetInt("userid"))] = FL_ENABLED;
}

public void OnClientCookiesCached(int client)
{
	if (SF_AddFlag(g_Flags[client], FL_OnClientCookiesCached) && g_Cookie && !IsFakeClient(client))
	{
		char s[4];
		GetClientCookie(client, g_Cookie, SZF(s));

		if (s[0] == '0') {
			g_Flags[client] &= ~FL_ENABLED;
		}
		else{
			g_Flags[client] |=  FL_ENABLED;
		}
	}
}

//	Это всё в .inc, который будет доступен позже:

/**
 *	Это звук?
 *
 *	@note					Пробелы по бокам удаляются. Если вернёт true, то все \ заменены на /.
 *
 *	@param s				Путь к звуку.
 *	@param bytes			Если уже известен размер s, укажите его.
 *
 *	@return					true = это .mp3 или .wav звук (неважно с sound/ он начинается или нет).
 */
stock bool SF_IsSound(char[] s, int bytes=0)
{
	int index;
	if (	s[0]
		&&	((bytes && (bytes >= 5/* x.mp3 */)) || (!bytes && ((bytes = TrimString(s)) >= 5/* x.mp3 */)))
		&&	((index = SF_FindCharInString(s, '.', /* reverse */true, bytes)) > 0)
		&&	(!strcmp(s[index+1], "mp3") || !strcmp(s[index+1], "wav"))	)
	{
		ReplaceString(s, ++bytes, "\\", "/");
		return true;
	}
	return false;
}

/**
 *	@param str				Строка, в которой ищем.
 *	@param c				Символ, который   ищем.
 *	@param reverse			Если true, то поиск справа налево, иначе слева направо.
 *	@param bytes			Если уже ивестно сколько ненулевых байт в str, укажите их, чтобы зря не вызывалось strlen.
 *	@param index			Если указан индекс, то поиск начинается с него.
 *
 *	@return					Индекс, или -1, если символ не найден.
 */
stock int SF_FindCharInString(const char[] str, char c, bool reverse=false, int bytes=0, int index=-1)
{
	if (str[0] && (bytes || (bytes = strlen(str)))) {
		if (reverse) {
			for (int i = index > 0 ? index : (bytes - 1); i > -1; i--) {
				if (str[i] == c) {
					return i;
				}
			}
		}
		else{
			for (int i = index > 0 ? index : 0; i < bytes; i++) {
				if (str[i] == c) {
					return i;
				}
			}
		}
	}
	return -1;
}

/**
 *	Преобразовать any (cell) значение в строку.
 *
 *	@param value		Значение, которое нужно преобразовать в строку.
 *	@param c			Тип: b (бит), c (char), d или i (int), u (unsigned int), f (float), x или X (hex в нижнем/ВЕРХНЕМ регистре).
 */
stock char[] SF_AnyToStr(any value, char c='u')
{
	static char  s_str[32];
	static char  s_fmt[] = "%u";
	
	s_fmt[1] = c;
	FormatEx(SZF(s_str), s_fmt, value);
	
	return s_str;
}

/**
 *	Если в flags нет flag, то flag добавляется и возвращает true.
 */
stock bool SF_AddFlag(int &flags, int flag)
{
	if (!HAS_FLAGS(flags, flag))
	{
		flags |= flag;
		return true;
	}
	return false;
}

/**
 *	После хука сразу же вызывает callback для получения текущего значения из @param convar.
 */
stock void SF_HookConVarChange(ConVar convar, ConVarChanged callback)
{
	if (convar)
	{
		convar.AddChangeHook(callback);
		
		Call_StartFunction(null, callback);
		Call_PushCell(convar);
		Call_Finish();
	}
}
